----------------------------------------------------------
-- noteType，addNote
--
--require'../data/text'
attr_type_to_name = {
	[1] = text.get("notification_1"),
	[2] = text.get("notification_2"),
	[3] = text.get("notification_3"),
	[4] = text.get("notification_4"),
	[5] = text.get("notification_5"),
	[6] = text.get("notification_6"),
	[7] = text.get("notification_7"),
	[8] = text.get("notification_8"),
	[9] = text.get("notification_9"),
	[10] = text.get("notification_10"),
	[11] = text.get("notification_11"),
	[12] = text.get("notification_12"),
	[13] = text.get("notification_13"),
	[14] = text.get("notification_14"),
	[15] = text.get("notification_15"),
	[16] = text.get("notification_16"),
	[17] = text.get("notification_17"),
	[18] = text.get("notification_18"),
	[19] = text.get("notification_19"),
	[20] = text.get("notification_20"),
	[21] = text.get("notification_21"),
	[22] = text.get("notification_22"),
	[23] = text.get("notification_23"),
	[24] = text.get("notification_24"),
	[25] = text.get("notification_25"),
	[26] = text.get("notification_26"),
	[27] = text.get("notification_27"),
	[28] = text.get("notification_28"),
	[30] = text.get("notification_29"),
	[31] = text.get("notification_30"),
	[700] = text.get("notification_31"),
	[701] = text.get("notification_32"),
	[800] = text.get("notification_32"),
}

local noteType = {
	DEBUG = 0,
	NORMAL = 1,
	TRIVIAL = 2,
	NORMAL_RED = 3,
	TRIVIAL_RED = 4,
	TOP = 5,
}

local addNote = function(note, ntType)
	ntType = ntType or noteType.NORMAL
	if note then
		cpnotification.addNote(note, ntType)
	end
end
-----------------------------------------------------------
--[[
namespace Error
{
	enum
	{
		Success			= 0,

		//
		//	General Error 1-99
		Unknown					=1,
		Script					=2,


		InvalidParam				=10,
		InvalidEntity				=11,
		InvalidCate				=12,
		InvalidType				=13,
		InvalidItem				=14,
		InvalidMgr				=15,
		InvalidScene				=16,
		InvalidStaticID				=17,
		InvalidStaticData			=18,

		NotEnoughEnhanceLevel		=21,
		NotEnoughLevel				=22,
		NotEnoughScrap				=23,
		NotEnoughItem				=24,
		NotEnoughSoul				=25,
		NotEnoughPower				=27,
		NotEnoughEquivalent		= 30,
		NotEnoughReq			= 31,
		NotEnoughMoney			= 32,
		NotEnoughGold			= 33,
		NotEnoughDiamond		= 34,
		NotEnoughReputation		= 35,
		NotEnoughHonor			= 36,
		NotEnoughBeauty			= 37,
		NotEnoughIntergration	= 38,
		NotEquip				= 39,

		StillInCD				=40,
		UpToLimit				=41,

		CanNotRemove				=50,
		CanNotReplace				=51,
		CanNotSameItem			=60,


		BoothDownSuccess		=95,  //下架成功
		BoothUpSuccess			=96,  //上架成功
		MarketSuccess			=97,  //摆摊成功
		ItemSuccess				=98,
		ItemFaild				=99,
	}

	enum EntityError
	{
		//
		//	Entity Error  100- 199
		RoleTooMuch		=	100,
		PetTooMuch		=	101,
		DogTooMuch		=	102,
		ItemTooMuch		=	103,

		MarketisOpen	=	110,
		MarketNotOpen	=	111,
		MarketNoItem	=   112,

		PetnotSleep		=	120,
		PetnotDead		=	121,
		PetnotOn		=	122,
	};

	enum ItemErrorCode
	{
		//
		//	Item   Error 200-299
		NotSuchSlot				= 200,

		Item_BagisFull				=204,
		Item_SuccessBagFull			=205,
		Item_AlreadyInlay			=215,
		Item_NoMatchClass = 216,
		Item_NoMatchGender = 217,

		Item_DestinationNotFound		=220,
	//	Item_PlayerLvlNotEnough			=221,


		Item_CDLocked				=226,
		Item_NotEnoughSlot			=227,
		Item_PlayerTypeErr			=228,

		Item_CanNotSell				=230,
		Item_CanNotDelete			=231,
		Item_CanNotMerge				=232,
		Item_CanNotForge				=233,

		Item_CanNotModifSysTime			=234,
		Item_CanNotBuy				=235,

		Item_CanNotUseOnMainRole		=236,
		Item_CanNotUseOnSubRole			=237,
		Item_SubRoleLvlLarger			=238,

		Item_InheritSlotCntErr			=239,
		Item_InheritNotEnough			=240,

		Item_MaxLvl					=241,
		Item_VipNotEnought			=242,

		Item_Failed					=243,

		Item_Same_Position			=250,

		Item_UnlockReqNotEnough		=260,
	};

	enum CombatErrorCode
	{
		//
		//	Combat Error 300-399
		Combat_Failed		= 300,
		Combat_OutOfMana	= 301,
		Combat_NotInRange	= 302,
		Combat_InvalidSkill	= 303,
		Combat_InCoolDown	= 305,
		Combat_PlayerIsDaze = 306,


		Combat_Skill_duplicate  = 310,
		Combat_Skill_LevelNotEnough = 311,
	};

	enum SceneErrorCode
	{
		//
		//	Scene Error  400-499
		NotInRegion		= 401,

		TeamMemberNotNear	= 410,
		TooManyTimes		= 411,
		EntranceClosed		= 412,

		Scene_Not_Allow		= 413,

		Scene_Not_Finish	= 414,

		Scene_Peace_Area	= 415,
	};

	enum
	{
	//	Quest Error  500-599
		InvalidQuestID		= 500,
		InvalidQuestState	= 501,
	};
}
--]]
-- 这个表的key代表errcode，source和target分别是event的来源和目标，返回值是提示信息和提示类型。
local getErrorMsg = {
	[0] = function(source, target)
		local note = ""
		local nType = noteType.NORMAL
		if source == "HandleMessageLoginResponse" then
			note = text.get("notification_errorcode_0")
			nType = noteType.NORMAL
		elseif source == "" then
		end
		return note, nType
	end,
	[1] = function(source, target)
		return text.get("notification_errorcode_1"), noteType.NORMAL
	end,
	[2] = function(source, target)
		return text.get("notification_errorcode_2"), noteType.NORMAL
	end,
	[3] = function(source, target)
		return text.get("notification_errorcode_3"), noteType.NORMAL
	end,
	[4] = function(source, target)
		return text.get("notification_errorcode_4"), noteType.NORMAL
	end,
	[5] = function(source, target)
		return text.get("notification_errorcode_5"), noteType.NORMAL
	end,
	[6] = function(source, target)
		return text.get("notification_errorcode_6"), noteType.NORMAL
	end,
	[7] = function(source, target)
		return text.get("notification_errorcode_7"), noteType.NORMAL
	end,
	[8] = function(source, target)
		return text.get("notification_errorcode_8"), noteType.NORMAL
	end,


	[10] = function(source, target)
		return text.get("notification_errorcode_10"), noteType.NORMAL
	end,
	[11] = function(source, target)
		--return "无效的实体!", noteType.NORMAL
		return "", noteType.NORMAL
	end,
	[12] = function(source, target)
		return text.get("notification_errorcode_12"), noteType.NORMAL
	end,
	[13] = function(source, target)
		return text.get("notification_errorcode_13"), noteType.NORMAL
	end,
	[14] = function(source, target)
		return text.get("notification_errorcode_14"), noteType.NORMAL
	end,
	[15] = function(source, target)
		return text.get("notification_errorcode_15"), noteType.NORMAL
	end,
	[16] = function(source, target)
		return text.get("notification_errorcode_16"), noteType.NORMAL
	end,
	[17] = function(source, target)
		return text.get("notification_errorcode_17"), noteType.NORMAL
	end,
	[18] = function(source, target)
		return text.get("notification_errorcode_18"), noteType.NORMAL
	end,
	[19] = function(source, target)
		return text.get("notification_errorcode_19"), noteType.NORMAL
	end,

	[20] = function(source, target)
		return text.get("notification_errorcode_20"), noteType.NORMAL
	end,
	[22] = function(source, target)
		return text.get("notification_errorcode_22"), noteType.NORMAL
	end,

	[24] = function(source, target)
		return text.get("notification_errorcode_24"), noteType.NORMAL
	end,

	[25] = function(source, target)
		return text.get("notification_errorcode_25"), noteType.NORMAL
	end,

	[27] = function(source, target)
		return text.get("notification_errorcode_27"), noteType.NORMAL
	end,

	[28] = function(source, target)
		return text.get("notification_errorcode_28"), noteType.NORMAL
	end,

	[29] = function(source, target)
		return text.get("notification_errorcode_29"), noteType.NORMAL
	end,

	[31] = function(source, target)
		return text.get("notification_errorcode_31"), noteType.NORMAL
	end,

	[32] = function(source, target)
		return text.get("notification_errorcode_32"), noteType.NORMAL
	end,

	[33] = function(source, target)
		return text.get("notification_errorcode_33"), noteType.NORMAL
	end,

	[34] = function(source, target)
		return text.get("notification_errorcode_34"), noteType.NORMAL
	end,

	[36] = function(source, target)
		return text.get("notification_errorcode_36"), noteType.NORMAL
	end,

	[39] = function(source, target)
		return text.get("notification_errorcode_39"), noteType.NORMAL
	end,

	[40] = function(source, target)
		return text.get("notification_errorcode_40"), noteType.NORMAL
	end,

	[41] = function(source, target)
		return text.get("notification_errorcode_41"), noteType.NORMAL
	end,

	[42] = function(source, target)
		return text.get("notification_errorcode_42"), noteType.NORMAL
	end,

	[43] = function(source, target)
		return text.get("notification_errorcode_43"), noteType.NORMAL
	end,

	[44] = function(source, target)
		return text.get("notification_errorcode_44"), noteType.NORMAL
	end,

	[45] = function(source, target)
		return text.get("notification_errorcode_45"), noteType.NORMAL
	end,

	[46] = function(source, target)
		return text.get("notification_errorcode_46"), noteType.NORMAL
	end,

	[49] = function(source, target)
		return text.get("notification_errorcode_49"), noteType.NORMAL
	end,
	[50] = function(source, target)
		return text.get("notification_errorcode_50"), noteType.NORMAL
	end,
	[51] = function(source, target)
		return text.get("notification_errorcode_51"), noteType.NORMAL
	end,
	[52] = function(source, target)
		return text.get("notification_errorcode_52"), noteType.NORMAL
	end,

	[53] = function(source, target)
		return text.get("notification_errorcode_53"), noteType.NORMAL
	end,
	[54] = function(source, target)
		return text.get("notification_errorcode_54"), noteType.NORMAL
	end,

	[55] = function(source, target)
		return text.get("notification_errorcode_55"), noteType.NORMAL
	end,

	[56] = function(source, target)
		return text.get("notification_errorcode_56"), noteType.NORMAL
	end,

	[57] = function(source, target)
		return text.get("notification_errorcode_57"), noteType.NORMAL
	end,
	[58] = function(source, target)
		return text.get("notification_errorcode_58"), noteType.NORMAL
	end,
	[61] = function(source, target)
		return text.get("notification_errorcode_61"), noteType.NORMAL
	end,

	[62] = function(source, target)
		return text.get("notification_errorcode_62"), noteType.NORMAL
	end,

	[63] = function(source, target)
		return text.get("notification_errorcode_63"), noteType.NORMAL
	end,

	[72] = function(source, target)
		return text.get("notification_errorcode_72"), noteType.NORMAL
	end,

	[73] = function(source, target)
		return text.get("notification_errorcode_73"), noteType.NORMAL
	end,

	[75] = function(source, target)
		return text.get("notification_errorcode_75"), noteType.NORMAL
	end,

	[76] = function(source, target)
		return text.get("notification_errorcode_76"), noteType.NORMAL
	end,

	[80] = function(source, target)
		return text.get("notification_errorcode_80"), noteType.NORMAL
	end,

	[81] = function(source, target)
		return text.get("notification_errorcode_81"), noteType.NORMAL
	end,

	[82] = function(source, target)
		return text.get("notification_errorcode_82"), noteType.NORMAL
	end,

	[85] = function(source, target)
		return text.get("notification_errorcode_85"), noteType.NORMAL
	end,

	[90] = function(source, target, data1, data2, data3)
		return text.get("notification_errorcode_90"), noteType.NORMAL
	end,
	[91] = function(source, target, data1, data2, data3)
		return text.get("notification_errorcode_91"), noteType.NORMAL
	end,

	[95] = function(source, target, data1, data2, data3)
		return text.get("notification_errorcode_95"), noteType.NORMAL_RED
	end,

	[96] = function(source, target)
		return text.get("notification_errorcode_96"), noteType.NORMAL
	end,

	[97] = function(source, target)
		return text.get("notification_errorcode_V10_1"), noteType.NORMAL
	end,

	[100] = function(source, target)
		return text.get("notification_errorcode_100"), noteType.NORMAL
	end,
	[101] = function(source, target)
		return text.get("notification_errorcode_101"), noteType.NORMAL
	end,
	[102] = function(source, target)
		return text.get("notification_errorcode_102"), noteType.NORMAL
	end,
	[103] = function(source, target)
		return text.get("notification_errorcode_103"), noteType.NORMAL
	end,

	[104] = function(source, target)
		return text.get("notification_errorcode_104"), noteType.NORMAL
	end,

	[105] = function(source, target)
		return text.get("notification_errorcode_105"), noteType.NORMAL
	end,

	[106] = function(source, target)
		return text.get("notification_errorcode_106"), noteType.NORMAL
	end,

	[107] = function(source, target)
		return text.get("notification_errorcode_107"), noteType.NORMAL
	end,

	[108] = function(source, target)
		return text.get("notification_errorcode_108"), noteType.NORMAL
	end,

	[109] = function(source, target)
		return text.get("notification_errorcode_109"), noteType.NORMAL
	end,

	[110] = function(source, target)
		return text.get("notification_errorcode_110"), noteType.NORMAL
	end,
	[111] = function(source, target)
		return text.get("notification_errorcode_111"), noteType.NORMAL
	end,
	[112] = function(source, target)
		return text.get("notification_errorcode_112"), noteType.NORMAL
	end,
	[113] = function(source, target)
		return text.get("notification_errorcode_113"), noteType.NORMAL
	end,

	[120] = function(source, target)
		return text.get("notification_errorcode_120"), noteType.NORMAL
	end,
	[121] = function(source, target)
		return text.get("notification_errorcode_121"), noteType.NORMAL
	end,
	[122] = function(source, target)
		return text.get("notification_errorcode_122"), noteType.NORMAL
	end,
	[123] = function(source, target)
		return text.get("notification_errorcode_123"), noteType.NORMAL
	end,
	[124] = function(source, target)
		return text.get("notification_errorcode_124"), noteType.NORMAL
	end,
	[125] = function(source, target)
		return text.get("notification_errorcode_125"), noteType.NORMAL
	end,
	[126] = function(source, target)
		return text.get("notification_errorcode_126"), noteType.NORMAL
	end,
	[127] = function(source, target)
		return text.get("notification_errorcode_127"), noteType.NORMAL
	end,
	[128] = function(source, target)
		return text.get("notification_errorcode_128"), noteType.NORMAL
	end,
	[130] = function(source, target)
		return text.get("notification_errorcode_130"), noteType.NORMAL
	end,
	[131] = function(source, target)
		return text.get("notification_errorcode_131"), noteType.NORMAL
	end,
	[132] = function(source, target)
		return text.get("notification_errorcode_132"), noteType.NORMAL
	end,

	[133] = function(source, target)
		return text.get("notification_errorcode_133"), noteType.NORMAL
	end,

	[134] = function(source, target)
		return text.get("notification_errorcode_134"), noteType.NORMAL
	end,

	[135] = function(source, target)
		return text.get("notification_errorcode_135"), noteType.NORMAL
	end,

	[136] = function(source, target)
		return text.get("notification_errorcode_136"), noteType.NORMAL
	end,

	[137] = function(source, target)
		return text.get("notification_errorcode_137"), noteType.NORMAL
	end,

	[140] = function(source, target)
		return text.get("notification_errorcode_140"), noteType.NORMAL
	end,
	[141] = function(source, target)
		return text.get("notification_errorcode_141"), noteType.NORMAL
	end,
	[142] = function(source, target)
		return text.get("notification_errorcode_142"), noteType.NORMAL
	end,
	[143] = function(source, target)
		return text.get("notification_errorcode_143"), noteType.NORMAL
	end,
	[150] = function(source, target)
		return text.get("notification_errorcode_150"), noteType.NORMAL
	end,
	[151] = function(source, target)
		return text.get("notification_errorcode_151"), noteType.NORMAL
	end,

	[160] = function(source, target)
		return text.get("notification_errorcode_160"), noteType.NORMAL
	end,

	[161] = function(source, target)
		return text.get("notification_errorcode_161"), noteType.NORMAL
	end,

	[162] = function(source, target)
		return text.get("notification_errorcode_162"), noteType.NORMAL
	end,

	[163] = function(source, target)
		return text.get("notification_errorcode_163"), noteType.NORMAL
	end,

	[164] = function(source, target)
		return text.get("notification_errorcode_164"), noteType.NORMAL
	end,

	[165] = function(source, target)
		return text.get("notification_errorcode_165"), noteType.NORMAL
	end,

	[170] = function(source, target)
		return text.get("notification_errorcode_170"), noteType.NORMAL
	end,

	[175] = function(source, target)
		return text.get("notification_errorcode_175"), noteType.NORMAL
	end,

	[176] = function(source, target)
		return text.get("notification_errorcode_176"), noteType.NORMAL
	end,

	[177] = function(source, target)
		return text.get("notification_errorcode_177"), noteType.NORMAL
	end,

	[178] = function(source, target)
		return text.get("notification_errorcode_178"), noteType.NORMAL
	end,

	[179] = function(source, target)
		return text.get("notification_errorcode_179"), noteType.NORMAL
	end,

	[180] = function(source, target)
		return text.get("notification_errorcode_180"), noteType.NORMAL
	end,

	[204] = function(source, target)
		return text.get("notification_errorcode_204"), noteType.NORMAL
	end,

	[216] = function(source, target)
		return text.get("notification_errorcode_216"), noteType.NORMAL
	end,
	[217] = function(source, target)
		return text.get("notification_errorcode_217"), noteType.NORMAL
	end,
	[220] = function(source, target)
		return text.get("notification_errorcode_220"), noteType.NORMAL
	end,

	[226] = function(source, target)
		return text.get("notification_errorcode_226"), noteType.NORMAL
	end,
	[227] = function(source, target)
		return text.get("notification_errorcode_227"), noteType.NORMAL
	end,

	[229] = function(source, target)
		return "", noteType.NORMAL
	end,

	[230] = function(source, target)
		return text.get("notification_errorcode_230"), noteType.NORMAL
	end,

	[231] = function(source, target)
		return text.get("notification_errorcode_231"), noteType.NORMAL
	end,

	[232] = function(source, target)
		return text.get("notification_errorcode_232"), noteType.NORMAL
	end,

	[244] = function(source, target)
		return text.get("notification_errorcode_244"), noteType.NORMAL
	end,

	[245] = function(source, target)
		return text.get("notification_errorcode_245"), noteType.NORMAL
	end,

	[246] = function(source, target)
		return text.get("notification_errorcode_246"), noteType.NORMAL
	end,

	[247] = function(source, target)
		return text.get("notification_errorcode_247"), noteType.NORMAL
	end,

	[248] = function(source, target)
		return text.get("notification_errorcode_248"), noteType.NORMAL
	end,

	[251] = function(source, target)
		return text.get("notification_errorcode_251"), noteType.NORMAL
	end,

	[252] = function(source, target)
		return text.get("notification_errorcode_252"), noteType.NORMAL
	end,

	[253] = function(source, target)
		return text.get("notification_errorcode_253"), noteType.NORMAL
	end,

	[254] = function(source, target)
		return text.get("notification_errorcode_254"), noteType.NORMAL
	end,

	[260] = function(source, target)
		return text.get("notification_errorcode_260"), noteType.NORMAL
	end,

	[262] = function(source, target)
		return text.get("notification_errorcode_262"), noteType.NORMAL
	end,

	[216] = function(source, target)
		return text.get("notification_errorcode_216"), noteType.NORMAL
	end,

	[217] = function(source, target)
		return text.get("notification_errorcode_217"), noteType.NORMAL
	end,

	[241] = function(source, target)
		return text.get("notification_errorcode_241"), noteType.NORMAL
	end,

	[243] = function(source, target)
		return text.get("notification_errorcode_243"), noteType.NORMAL
	end,

	[249] = function(source, target)
		return text.get("notification_errorcode_249"), noteType.NORMAL
	end,

	[250] = function(source, target)
		return text.get("notification_errorcode_250"),noteType.NORMAL
	end,
	[251] = function(source, target)
		return text.get("notification_errorcode_251"),noteType.NORMAL
	end,
	[252] = function(source, target)
		return text.get("notification_errorcode_252"),noteType.NORMAL
	end,
	[253] = function(source, target)
		return text.get("notification_errorcode_253"),noteType.NORMAL
	end,
	[254] = function(source, target)
		return text.get("notification_errorcode_254"),noteType.NORMAL
	end,
	[255] = function(source, target)
		return text.get("notification_errorcode_255"),noteType.NORMAL
	end,

	[260] = function(source, target)
		return text.get("notification_errorcode_260"), noteType.NORMAL
	end,

	[261] = function(source, target)
		return text.get("notification_errorcode_261"), noteType.NORMAL
	end,

	[265] = function(source, target)
		return text.get("notification_errorcode_265"), noteType.NORMAL
	end,

	[266] = function(source, target)
		return text.get("notification_errorcode_266"), noteType.NORMAL
	end,


	[280] = function(source, target)
		local sid=tonumber(target)
		local eu=gdItems[sid]
		if	eu then
			local name=eu.name
			return text.get("notification_errorcode_280_1")..name, noteType.NORMAL
		end
		return text.get("notification_errorcode_280_2"), noteType.NORMAL
	end,

	[281] = function(source, target)
		local sid=tonumber(target)
		local eu=gdItems[sid]
		if	eu then
			local name=eu.name
			return text.get("notification_errorcode_281_1")..name, noteType.NORMAL
		end
		return text.get("notification_errorcode_280_2"), noteType.NORMAL
	end,

	[283] = function(source, target)
		return text.get("notification_errorcode_283"), noteType.NORMAL
	end,

	[290] = function(source, target)
		return text.get("notification_errorcode_V10_7"), noteType.NORMAL
	end,

	[300] = function(source, target)
		return text.get("notification_errorcode_300"), noteType.NORMAL
	end,

	[301] = function(source, target)
		return text.get("notification_errorcode_301"), noteType.NORMAL
	end,

	[302] = function(source, target)
		return text.get("notification_errorcode_302"), noteType.NORMAL
	end,

	[303] = function(source, target)
		return text.get("notification_errorcode_303"), noteType.NORMAL
	end,

	[305] = function(source, target)
		--return "技能冷却中！", noteType.NORMAL
		return "", noteType.NORMAL
	end,

	[306] = function(source, target)
		return text.get("notification_errorcode_306"), noteType.NORMAL
	end,

	[310] = function(source, target)
		return text.get("notification_errorcode_310"), noteType.NORMAL
	end,

	[311] = function(source, target)
		return text.get("notification_errorcode_311"), noteType.NORMAL
	end,

	[401] = function(source, target)
		return text.get("notification_errorcode_401"), noteType.NORMAL
	end,
	[410] = function(source, target)
		return text.get("notification_errorcode_410"), noteType.NORMAL
	end,
	[411] = function(source, target)
		return text.get("notification_errorcode_411"), noteType.NORMAL
	end,
	[412] = function(source, target)
		return text.get("notification_errorcode_412"), noteType.NORMAL
	end,
	[413] = function(source, target)
		return text.get("notification_errorcode_413"), noteType.NORMAL
	end,
	[414] = function(source, target)
		return text.get("notification_errorcode_414"), noteType.NORMAL
	end,
	[415] = function(source, target)
		return text.get("notification_errorcode_415"), noteType.NORMAL
	end,

	[416] = function(source, target)
		return text.get("notification_errorcode_416"), noteType.NORMAL
	end,

	[417] = function(source, target)
		return text.get("notification_errorcode_417"), noteType.NORMAL
	end,

	[420] = function(source, target)
		return text.get("notification_errorcode_420"), noteType.NORMAL
	end,


	[450] = function(source, target)
		return text.get("notification_errorcode_450"), noteType.NORMAL
	end,

	[451] = function(source, target)
		return text.get("notification_errorcode_451"), noteType.NORMAL
	end,

	[460] = function(source, target)
		return text.get("notification_errorcode_460"), noteType.NORMAL
	end,

	[500] = function(source, target)
		return text.get("notification_errorcode_500"), noteType.NORMAL
	end,
	[501] = function(source, target)
		return text.get("notification_errorcode_501"), noteType.NORMAL
	end,
	[502] = function(source, target)
		return text.get("notification_errorcode_502"), noteType.NORMAL
	end,

	[510] = function(source, target)
		return text.get("notification_errorcode_510"), noteType.NORMAL
	end,
	[511] = function(source, target)
		return text.get("notification_errorcode_511"), noteType.NORMAL
	end,

	[603] = function(source, target)
		return text.get("notification_errorcode_603"), noteType.NORMAL
	end,

	[604] = function(source, target)
		return text.get("notification_errorcode_604"), noteType.NORMAL
	end,

	[605] = function(source, target)
		return text.get("notification_errorcode_605"), noteType.NORMAL
	end,

	[606] = function(source, target)
		return text.get("notification_errorcode_606"), noteType.NORMAL
	end,

	[607] = function(source, target)
		return text.get("notification_errorcode_607"), noteType.NORMAL
	end,

	[608] = function(source, target)
		return text.get("notification_errorcode_608"), noteType.NORMAL
	end,

	[700] = function(source, target)
		return text.get("notification_errorcode_700"), noteType.NORMAL
	end,
	[701] = function(source, target)
		return text.get("notification_errorcode_701"), noteType.NORMAL
	end,
	[702] = function(source, target)
		return text.get("notification_errorcode_702"), noteType.NORMAL
	end,
	[703] = function(source, target)
		return text.get("notification_errorcode_703"), noteType.NORMAL
	end,

	[800] = function(source, target)
		return text.get("notification_errorcode_800"), noteType.NORMAL
	end,
	[801] = function(source, target)
		return text.get("notification_errorcode_801"), noteType.NORMAL
	end,
	[802] = function(source, target)
		return text.get("notification_errorcode_802"), noteType.NORMAL
	end,
	[803] = function(source, target)
		return text.get("notification_errorcode_803"), noteType.NORMAL
	end,
	[804] = function(source, target)
		return text.get("notification_errorcode_804"), noteType.NORMAL
	end,
	[805] = function(source, target)
		return text.get("notification_errorcode_805"), noteType.NORMAL
	end,
	[806] = function(source, target)
		return text.get("notification_errorcode_806"), noteType.NORMAL
	end,
	[807] = function(source, target)
		return text.get("notification_errorcode_807"), noteType.NORMAL
	end,

	[902] = function(source, target)
		return text.get("notification_errorcode_902"), noteType.NORMAL
	end,
	[903] = function(source, target)
		return text.get("notification_errorcode_903"), noteType.NORMAL
	end,
	[904] = function(source, target)
		return text.get("notification_errorcode_904"), noteType.NORMAL
	end,
	[905] = function(source, target)
		return text.get("notification_errorcode_905"), noteType.NORMAL
	end,
	[906] = function(source, target)
		return text.get("notification_errorcode_906"), noteType.NORMAL
	end,
	[907] = function(source, target)
		return text.get("notification_errorcode_907"), noteType.NORMAL
	end,
	[908] = function(source, target)
		return text.get("notification_errorcode_908"), noteType.NORMAL
	end,
	[911] = function(source, target)
		return text.get("notification_errorcode_911"), noteType.NORMAL
	end,
	[912] = function(source, target)
		return text.get("notification_errorcode_912"), noteType.NORMAL
	end,
	[913] = function(source, target)
		return text.get("notification_errorcode_913"), noteType.NORMAL
	end,
	[914] = function(source, target)
		return text.get("notification_errorcode_914"), noteType.NORMAL
	end,
	[915] = function(source, target)
		return text.get("notification_errorcode_915"), noteType.NORMAL
	end,
	[916] = function(source, target)
		return text.get("notification_errorcode_916"), noteType.NORMAL
	end,
	[917] = function(source, target)
		return text.get("notification_errorcode_917"), noteType.NORMAL
	end,
	[919] = function(source, target)
		return text.get("notification_errorcode_919"), noteType.NORMAL
	end,
	[930] = function(source, target)
		return text.get("notification_errorcode_930"), noteType.NORMAL
	end,
	[931] = function(source, target)
		return text.get("notification_errorcode_931"), noteType.NORMAL
	end,
	[932] = function(source, target)
		return text.get("notification_errorcode_932"), noteType.NORMAL
	end,
	[933] = function(source, target)
		return text.get("notification_errorcode_933"), noteType.NORMAL
	end,
	[934] = function(source, target)
		return text.get("notification_errorcode_934"), noteType.NORMAL
	end,
	[935] = function(source, target)
		return text.get("notification_errorcode_935"), noteType.NORMAL
	end,
	[936] = function(source, target)
		return text.get("notification_errorcode_936"), noteType.NORMAL
	end,

	[938] = function(source, target)
		return text.get("notification_errorcode_938"), noteType.NORMAL
	end,

	[940] = function(source, target)
		return text.get("notification_errorcode_940"), noteType.NORMAL
	end,

	[941] = function(source, target)
		return text.get("notification_errorcode_941"), noteType.NORMAL
	end,

	[942] = function(source, target)
		return text.get("notification_errorcode_942"), noteType.NORMAL
	end,

	[943] = function(source, target)
		return text.get("notification_errorcode_943"), noteType.NORMAL
	end,

	[944] = function(source, target)
		return text.get("notification_errorcode_944"), noteType.NORMAL
	end,
	[945] = function(source, target)
		return text.get("notification_errorcode_945"), noteType.NORMAL
	end,
	[946] = function(source, target)
		return text.get("notification_errorcode_946"), noteType.NORMAL
	end,
	[950] = function(source, target)
		return text.get("notification_errorcode_950"), noteType.NORMAL
	end,
	[952] = function(source, target)
		return text.get("notification_errorcode_952"), noteType.NORMAL
	end,
	[953] = function(source, target)
		return text.get("notification_errorcode_953"), noteType.NORMAL
	end,
	[954] = function(source, target)
		return text.get("notification_errorcode_954"), noteType.NORMAL
	end,
	[955] = function(source, target)
		return text.get("notification_errorcode_955"), noteType.NORMAL
	end,
	[956] = function(source, target)
		return text.get("notification_errorcode_956"), noteType.NORMAL
	end,
	[957] = function(source, target)
		return text.get("notification_errorcode_957"), noteType.NORMAL
	end,
	[958] = function(source, target)
		return text.get("notification_errorcode_958"), noteType.NORMAL
	end,
	[959] = function(source, target)
		return text.get("notification_errorcode_V10_2"), noteType.NORMAL
	end,
	[960] = function(source, target)
		return text.get("notification_errorcode_V10_3"), noteType.NORMAL
	end,
	[961] = function(source, target)
		return text.get("notification_errorcode_V10_4"), noteType.NORMAL
	end,
	[962] = function(source, target)
		return text.get("notification_errorcode_V10_5"), noteType.NORMAL
	end,
	[963] = function(source, target)
		return text.get("notification_errorcode_V10_6"), noteType.NORMAL
	end,


	[1001] = function(source, target)
		return text.get("notification_errorcode_1001"), noteType.NORMAL
	end,

	[1002] = function(source, target)
		return text.get("notification_errorcode_1002"), noteType.NORMAL
	end,

	[1003] = function(source, target)
		return text.get("notification_errorcode_1003"), noteType.NORMAL
	end,

	[1004] = function(source, target)
		return text.get("notification_errorcode_1004"), noteType.NORMAL
	end,

	[1005] = function(source, target)
		return text.get("notification_errorcode_1005"), noteType.NORMAL
	end,


	[1010] = function(source, target)
		return text.get("notification_errorcode_1010"), noteType.NORMAL
	end,

	[1011] = function(source, target)
		return text.get("notification_errorcode_1011"), noteType.NORMAL
	end,

	[1013] = function(source, target)
		return text.get("notification_errorcode_1013"), noteType.NORMAL
	end,

	[1020] = function(source, target)
		return text.get("notification_errorcode_1020"), noteType.NORMAL
	end,
	[1021] = function(source, target)
		return text.get("notification_errorcode_1021"), noteType.NORMAL
	end,
	[1022] = function(source, target)
		return text.get("notification_errorcode_1022"), noteType.NORMAL
	end,

	[1023] = function(source, target)
		return text.get("notification_errorcode_1023"), noteType.NORMAL
	end,

	[1040] = function(source, target)
		return text.get("notification_errorcode_1040"), noteType.NORMAL
	end,

	[1041] = function(source, target)
		return text.get("notification_errorcode_1041"), noteType.NORMAL
	end,

	[1042] = function(source, target)
		return text.get("notification_errorcode_1042"), noteType.NORMAL
	end,

	[1043] = function(source, target)
		return text.get("notification_errorcode_1043"), noteType.NORMAL
	end,

	[1050] = function(source, target)
		return text.get("notification_errorcode_1050"),noteType.NORMAL
	end,

	[1051] = function(source, target)
		return text.get("notification_errorcode_1051"), noteType.NORMAL
	end,

	[1052] = function(source, target)
		return text.get("notification_errorcode_1052"),noteType.NORMAL
	end,

	[1053] = function(source, target)
		return text.get("notification_errorcode_1053"),noteType.NORMAL
	end,

	[1060] = function(source, target)
		return text.get("notification_errorcode_1060"),noteType.NORMAL
	end,

	[1061] = function(source, target)
		return text.get("notification_errorcode_1061"),noteType.NORMAL
	end,

	[1062] = function(source, target)
		return text.get("notification_errorcode_1062"),noteType.NORMAL
	end,

	[1071] = function(source, target)
		return text.get("notification_errorcode_1071"), noteType.NORMAL
	end,

	[1080] = function(source, target)
		return text.get("notification_errorcode_1080"), noteType.NORMAL
	end,
	[1081] = function(source, target)
		return text.get("notification_errorcode_1081"), noteType.NORMAL
	end,
	[1082] = function(source, target)
		return text.get("notification_errorcode_1082"), noteType.NORMAL
	end,
	[1083] = function(souce, target)
		return text.get("notification_errorcode_1083"), noteType.NORMAL
	end,

	[1102] = function(source, target)
		return text.get("notification_errorcode_1102"), noteType.NORMAL
	end,

	[1104] = function(source, target)
		return text.get("notification_errorcode_1104"), noteType.NORMAL
	end,

	[1107] = function(source, target)
		return text.get("notification_errorcode_1107"), noteType.NORMAL
	end,

	[1108] = function(source, target)
		return text.get("notification_errorcode_1108"), noteType.NORMAL
	end,
	[1109] = function(source, target)
		return text.get("notification_errorcode_1109"), noteType.NORMAL
	end,

	[1111] = function(source, target)
		return text.get("notification_errorcode_1111"), noteType.NORMAL
	end,

	[1111] = function(source, target)
		return text.get("notification_errorcode_1111"), noteType.NORMAL
	end,

	[1112] = function(source, target)
		return text.get("notification_errorcode_1112"), noteType.NORMAL
	end,

	[1113] = function(source, target)
		return text.get("notification_errorcode_1113"), noteType.NORMAL
	end,

	[1114] = function(source, target)
		return text.get("notification_errorcode_1114"), noteType.NORMAL
	end,

	[1115] = function(source, target)
		return text.get("notification_errorcode_1115"), noteType.NORMAL
	end,

	[1116] = function(source, target)
		return text.get("notification_errorcode_1116"), noteType.NORMAL
	end,

	[1117] = function(source, target)
		return text.get("notification_errorcode_1117"), noteType.NORMAL
	end,

	[1118] = function(source, target)
		return text.get("notification_errorcode_1118"), noteType.NORMAL
	end,

	[1119] = function(source, target)
		return text.get("notification_errorcode_1119"), noteType.NORMAL
	end,

	[1120] = function(source, target)
		return text.get("notification_errorcode_1120"), noteType.NORMAL
	end,

	[1121] = function(source, target)
		return	text.get("notification_errorcode_1121"), noteType.NORMAL
	end,

	[1122] = function(source, target)
		return text.get("notification_errorcode_V10_8"), noteType.NORMAL
	end,

	[1202] = function(source, target)
		return text.get("notification_errorcode_1202"), noteType.NORMAL
	end,

	[1210] = function(source, target)
		return text.get("notification_errorcode_1210"), noteType.NORMAL
	end,

	[1211] = function(source, target)
		return text.get("notification_errorcode_1211"), noteType.NORMAL
	end,

	[1212] = function(source, target)
		return text.get("notification_errorcode_1212"), noteType.NORMAL
	end,

	[1213] = function(source, target)
		return text.get("notification_errorcode_1213"), noteType.NORMAL
	end,

	[1214] = function(source, target)
		return text.get("notification_errorcode_1214"), noteType.NORMAL
	end,

	[1220] = function(source, target)
		return text.get("notification_errorcode_1220"), noteType.NORMAL
	end,

	[1221] = function(source, target)
		return text.get("notification_errorcode_1221"), noteType.NORMAL
	end,

	[1230] = function(source, target)
		return text.get("notification_errorcode_1230"), noteType.NORMAL
	end,

	[1231] = function(source, target)
		return text.get("notification_errorcode_1231"), noteType.NORMAL
	end,

	[1310] = function(source, target)
		return text.get("notification_errorcode_1310"), noteType.NORMAL
	end,

	[1311] = function(source, target)
		return text.get("notification_errorcode_1311"), noteType.NORMAL
	end,
	[1312] = function(source, target)
		return text.get("notification_errorcode_1312"), noteType.NORMAL
	end,
	[1315] = function(source, target)
		return text.get("notification_errorcode_1315"),noteType.NORMAL
	end,

	[10000] = function(source, target)
		return text.get("notification_errorcode_10000"), noteType.NORMAL
	end,
	[10001] = function(source, target)
		return text.get("notification_errorcode_10001"), noteType.NORMAL
	end,
	[10002] = function(source, target)
		return text.get("notification_errorcode_10002"), noteType.NORMAL
	end,

	[10010] = function(source, target)
		return text.get("notification_errorcode_10010"), noteType.NORMAL
	end,
	[10011] = function(source, target)
		return text.get("notification_errorcode_10011"), noteType.NORMAL
	end,
	[10012] = function(source, target)
		return text.get("notification_errorcode_10012"), noteType.NORMAL
	end,
	[10013] = function(source, target)
		return text.get("notification_errorcode_10013"), noteType.NORMAL
	end,
	[10014] = function(source, target)
		return text.get("notification_errorcode_10014"), noteType.NORMAL
	end,
	[10015] = function(source, target)
		return text.get("notification_errorcode_10015"), noteType.NORMAL
	end,
	[10016] = function(source, target)
		return text.get("notification_errorcode_10016"), noteType.NORMAL
	end,
	[10017] = function(source, target)
		return text.get("notification_errorcode_10017"), noteType.NORMAL
	end,
	[10018] = function(source, target)
		return text.get("notification_errorcode_10018"), noteType.NORMAL
	end,
	[10019] = function(source, target)
		return text.get("notification_errorcode_10019"), noteType.NORMAL
	end,

	[10100] = function(source, target)
		return text.get("notification_errorcode_10100"), noteType.NORMAL
	end,
	[10101] = function(source, target)
		return text.get("notification_errorcode_10101"), noteType.NORMAL
	end,
	[10102] = function(source, target)
		return text.get("notification_errorcode_10102"), noteType.NORMAL
	end,
	[10103] = function(source, target)
		return text.get("notification_errorcode_10103"), noteType.NORMAL
	end,
	[10104] = function(source, target)
		return text.get("notification_errorcode_10104"), noteType.NORMAL
	end,
	[10105] = function(source, target)
		return text.get("notification_errorcode_10105"), noteType.NORMAL
	end,
	[10106] = function(source, target)
		return text.get("notification_errorcode_10106"), noteType.NORMAL
	end,


	[11001] = function(source, target)
		return text.get("notification_errorcode_11001"), noteType.NORMAL
	end,
	[11002] = function(source, target)
		return text.get("notification_errorcode_11002"), noteType.NORMAL
	end,
	[11003] = function(source, target)
		return text.get("notification_errorcode_11003"), noteType.NORMAL
	end,

	[11010] = function(source, target)
		return text.get("notification_errorcode_11010"), noteType.NORMAL
	end,

	[11011] = function(source, target)
		return "", noteType.NORMAL
	end,

	[11012] = function(source, target)
		return text.get("notification_errorcode_11012"), noteType.NORMAL
	end,

	[-997] =  function(source, target)
		return text.get("notification_errorcode_V10_9"), noteType.NORMAL
	end,
	[-998] =  function(source, target)
		return text.get("notification_errorcode_V10_10"), noteType.NORMAL
	end,

	[-999] =  function(source, target)
		return text.get("notification_errorcode_V10_11"), noteType.NORMAL
	end,

	[-1000] =  function(source, target)
		return text.get("notification_errorcode_-1000"), noteType.NORMAL
	end,

	[-1001] =  function(source, target)
		return text.get("notification_errorcode_-1001"), noteType.NORMAL
	end,

	[-1002] =  function(source, target)
		return text.get("notification_errorcode_-1002"), noteType.NORMAL
	end,

	[-1003] =  function(source, target)
		return text.get("notification_errorcode_-1003"), noteType.NORMAL
	end,

	[-1004] =  function(source, target)
		return text.get("notification_errorcode_-1004"), noteType.NORMAL
	end,

	[-1006] =  function(source, target)
		return text.get("notification_errorcode_-1006"), noteType.NORMAL
	end,

	[-10007] =  function(source, target)
		return text.get("notification_errorcode_-10007"), noteType.NORMAL
	end,

	[-2001] =  function(source, target)
		return text.get("notification_errorcode_-2001"), noteType.NORMAL
	end,

	[-2002] =  function(source, target)
		return text.get("notification_errorcode_-2002"), noteType.NORMAL
	end,

	[-2003] =  function(source, target)
		return text.get("notification_errorcode_-2003"), noteType.NORMAL
	end,

	[-2004] =  function(source, target)
		return text.get("notification_errorcode_-2004"), noteType.NORMAL
	end,

	[-4000] =  function(source, target)
		return text.get("notification_errorcode_-4000"), noteType.NORMAL
	end,

	[-4001] =  function(source, target)
		return text.get("notification_errorcode_-4001"), noteType.NORMAL
	end,

	[-4002] =  function(source, target)
		return text.get("notification_errorcode_-4002"), noteType.NORMAL
	end,

	[-4003] =  function(source, target)
		return text.get("notification_errorcode_-4003"), noteType.NORMAL
	end,

	[-4004] =  function(source, target)
		return text.get("notification_errorcode_-4004"), noteType.NORMAL
	end,

	[-4005] =  function(source, target)
		return text.get("notification_errorcode_-4005"), noteType.NORMAL
	end,

	[-4010] =  function(source, target)
		return text.get("notification_errorcode_-4010"), noteType.NORMAL
	end,

	[-5000] =  function(source, target)
		return text.get("notification_errorcode_-5000"), noteType.NORMAL
	end,

	[-5001] =  function(source, target)
		return text.get("notification_errorcode_-5001"), noteType.NORMAL
	end,

	[-5002] =  function(source, target)
		return text.get("notification_errorcode_-5002"), noteType.NORMAL
	end,

	[-5003] =  function(source, target)
		return text.get("notification_errorcode_-5003"), noteType.NORMAL
	end,

	[-5004] =  function(source, target)
		return text.get("notification_errorcode_-5004"), noteType.NORMAL
	end,
	[-5005] =  function(source, target)
		return text.get("notification_errorcode_-5005"), noteType.NORMAL
	end,

	[-6000] =  function(source, target)
		return "Exceeding the maximum number of times", noteType.NORMAL
	end,

	[-6001] = function(source, target)
		return "in 30s only one time !", noteType.NORMAL
	end,

	[-6007] = function(source, target)
		return "invite Success !", noteType.NORMAL
	end,

	[-6008] = function(source, target)
		return "repeat invite !", noteType.NORMAL
	end,

	[-6009] = function(source, target)
		return "invite failed !", noteType.NORMAL
	end,

	[-6010] = function(source, target)
		return "invite times limit !", noteType.NORMAL
	end,

	[-6011] = function(source, target) --  out of activity time
		return "SỰ KIỆN CHƯA DIỄN RA !", noteType.NORMAL
	end,
	[-9000] =  function(source, target)
		return text.get("notification_errorcode_V10_12"), noteType.NORMAL
	end,
	[-9001] =  function(source, target)
		return text.get("notification_errorcode_V10_13"), noteType.NORMAL
	end,
	[-9002] =  function(source, target)
		return text.get("notification_errorcode_V10_14"), noteType.NORMAL
	end,
	[-9003] =  function(source, target)
		return text.get("notification_errorcode_V10_15"), noteType.NORMAL
	end,
	[-9004] =  function(source, target)
		return text.get("notification_errorcode_V10_16"), noteType.NORMAL
	end,
	[-9006] =  function(source, target)
		return text.get("notification_errorcode_V10_17"), noteType.NORMAL
	end,
	[-90007] =  function(source, target)
		return text.get("notification_errorcode_V10_18"), noteType.NORMAL
	end,
}

---------------------------------------------------------
--[[

--]]
-- 这个表的key代表opcode，source和target同上，data1，data2，data3是扩展整型数据，返回同上。
local getOperationMsg = {
	[0] = function(source, target, data1, data2, data3)
		return "", noteType.NORMAL
	end,

	[1] = function(source, target, data1, data2, data3)
		log.error("getOperationMsg: " .. source .. target .. data1 .. data2 .. data3)
		return "", noteType.NORMAL
	end,

	[107] = function(source, target, data1, data2, data3)
		log.info("source"..source)
		log.info("target"..target)
		log.info("data1"..data1)
		log.info("data2"..data2)
		log.info("data3"..data3)
		local sid=tonumber(data1)
		local reason=tonumber(data3)
		local count=tonumber(data2)
		local item=gdItems[sid]
		local reasonstr = "reason = "..reason
		if reason==0 then
			reasonstr = ""
		end
		local notetype = noteType.NORMAL
		if data3==Opcode.Op_Loot  or data3==Opcode.Op_pet_pick_up then
			--
			--	战利品(物品, 经验)在3号提示区域
			notetype = noteType.TRIVIAL
		end
		if item then
			local name=item.name
			if count>0 then
				return text.get("notification_bottom_1") .. count ..name, notetype
			else
				return text.get("notification_bottom_2") .. -count ..name, notetype
			end
		else
			if count>0 then
				return text.get("notification_bottom_1") .. count ..text.get("notification_bottom_3")..sid, notetype
			else
				return text.get("notification_bottom_2") .. -count ..text.get("notification_bottom_3")..sid, notetype
			end
		end

	end,

	--
	--	获得经验
	[204] = function(source, target, data1, data2, data3)
		local notetype = noteType.NORMAL
		if data1<=0 then
			--
			--notetype = noteType.TRIVIAL
			return text.get("notification_bottom_4"), notetype
		else
			return text.get("notification_bottom_5").."x".. data1, notetype
		end
	end,

	--
	--	获得经验
	[205] = function(source, target, data1, data2, data3)
		local notetype = noteType.NORMAL
		local diffExp = data2 or 0
		if (diffExp <= 0) then
			return "", notetype
		end

		if (data3 == Opcode.Op_Loot) or (data3 == Opcode.Op_pet_pick_up) then
			--
			--	战利品(物品, 经验)在3号提示区域
			notetype = noteType.TRIVIAL
		end
		return text.get("notification_bottom_6").."x".. data2, notetype
	end,

	--
	--	宠物死亡
	[206] = function(source, target, data1, data2, data3)
		local notetype = noteType.NORMAL
		if source =="HandleMessageUpdPetLvlExpNotify" then
			if data1==0 then
				return text.get("notification_bottom_7"), notetype
			else
				return text.get("notification_bottom_8").. data1..text.get("notification_bottom_9"), notetype
			end
		end
	end,

	--
	-- entity prop update
	[210] = function(source, target, data1, data2, data3, data4)
		local propID = data1 or 0
		local propTable = {
			[111] = text.get("notification_bottom_10"),
			[117] = text.get("notification_bottom_11"),
			[115] = text.get("notification_bottom_12"),
		}

		local msg = propTable[propID]
		if msg then
			local diff = data3 or 0
			if (diff > 0) then
				return msg .. text.get("notification_bottom_13") .. diff, noteType.NORMAL
			elseif (diff < 0) then
				return msg .. text.get("notification_bottom_14") .. -diff, noteType.NORMAL_RED
			end
		end
		return "", noteType.NORMAL
	end,

	--
	--宠物获得经验
	[212] = function(source, target, data1, data2, data3)
		local notetype = noteType.NORMAL
		if source =="HandleMessageUpdPetLvlExpNotify" then
			if data1==0 then
				return "", notetype
			else
				return text.get("notification_bottom_5").. data1, notetype
			end
		end
	end,

	[220] = function(source, target, data1, data2, data3)-- 开启荣誉
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		elseif attr_type_to_name[data1] and attr_type_to_name[data1] ~="" then
			if count>0 then
				return (attr_type_to_name[data1] or "") .. "+"..count, noteType.NORMAL
			elseif count<0 then
				return (attr_type_to_name[data1] or "") .. count, noteType.NORMAL
			end
		end
	end,

	[230] = function(source, target, data1, data2, data3) -- 技能获得
		if (data1 > 0) then
			local name = g_get_skill_name(data1)
			if (name ~= "") then
				return text.get("notification_bottom_17") .. name, noteType.NORMAL
			end
		end
	end,

	[231] = function(source, target, data1, data2, data3) -- 技能升级
		if (data1 > 0) then
			local name = g_get_skill_name(data1)
			if (name ~= "") then
				return  name .. text.get("notification_bottom_18") , noteType.NORMAL
			end
		end
	end,



	[250] = function(source, target, data1, data2, data3)--装备穿上 脱下
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
		return "", noteType.NORMAL
	end,

	[261] = function(source, target, data1, data2, data3)
		return text.get("notification_bottom_19"), noteType.NORMAL
	end,
	[262] = function(source, target, data1, data2, data3)
		return text.get("notification_bottom_20"), noteType.NORMAL
	end,


	[405] = function(source, target, data1, data2, data3)--装备升级
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
	end,

	[406] = function(source, target, data1, data2, data3)--装备转生
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
	end,

	[407] = function(source, target, data1, data2, data3)--装备强化
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
	end,

	[408] = function(source, target, data1, data2, data3)--装备鉴定
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
	end,

	[409] = function(source, target, data1, data2, data3)--装备清洗
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
	end,

	[412] = function(source, target, data1, data2, data3)--极品属性转移
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
	end,

	[415] = function(source, target, data1, data2, data3)--装备打磨
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15") ..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16") ..-count, noteType.NORMAL_RED
			end
		end
	end,

	[416] = function(source, target, data1, data2, data3)--装备完美强化
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
	end,

	[422] = function(source, target, data1, data2, data3)--鉴定转移
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
	end,

	[421] = function(source, target, data1, data2, data3)--强化转移
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
	end,

	[423] = function(source, target, data1, data2, data3)--极品清洗
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
	end,

	[418] = function(source, target, data1, data2, data3, data4)
		local iid = tonumber(data3)
		local item=gdItems[tonumber(data1)]
		local notetype = noteType.NORMAL

		if data4==503 then
			return "", notetype
		end

		if data4==Opcode.Op_Loot  or data4==Opcode.Op_pet_pick_up then
			--
			--	战利品(物品, 经验)在3号提示区域
			notetype = noteType.TRIVIAL
		end

		if item then
			return text.get("notification_bottom_1")..item.name.."x" .. data2, notetype
		else
			return text.get("notification_bottom_21") .. ""
		end
	end,

	[419] = function(source, target, data1, data2, data3)
		local reason = tonumber(data3)
		local reasonTable = {
			[110] = text.get("notification_bottom_22"),
			[500] = text.get("notification_bottom_22"),
			[502] = text.get("notification_bottom_23"),
			[504] = text.get("notification_bottom_24"),
		}

		local ntType = noteType.TRIVIAL_RED

		if reason==503 then
			return "", ntType
		elseif reason==500 then
			ntType = noteType.NORMAL
		end

		local reasonStr = reasonTable[reason]
		if not(reasonStr) then
			reasonStr = text.get("notification_bottom_23")
			ntType = noteType.TRIVIAL_RED
		end
		local item=gdItems[tonumber(data1)]
		if item then
			return reasonStr .. item.name .. "x" .. data2, ntType
		end
		return reasonStr .. data1 .. "x" .. data2, ntType
	end,

	[465] = function(source, target, data1, data2, data3)--装备耐久恢复
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
		return "", noteType.NORMAL
	end,
	[466] = function(source, target, data1, data2, data3)--装备耐久变为0
		local count=tonumber(data2)
		if data1==117 then
			if count>0 then
				return text.get("notification_bottom_15")..count, noteType.NORMAL
			elseif count<0 then
				return text.get("notification_bottom_16")..-count, noteType.NORMAL_RED
			end
		end
		return "", noteType.NORMAL
	end,

	[502] = function(source, target, data1, data2, data3, data4)--物品使用
		local count=tonumber(data2)
		local nowdata=tonumber(data3)
		if source == "HandleMessageItemUpdData" then
			if data1==14 then
				local itemSID = tonumber(data4)
				if count>0 then
					return text.get("notification_bottom_25"), noteType.NORMAL
				elseif count<0 then
					return text.get("notification_bottom_26"), noteType.NORMAL_RED
				elseif count==0 then
					return text.get("notification_bottom_27"), noteType.NORMAL_RED
				end
			end
		end
		return "", noteType.NORMAL
	end,

	[601] = function(source, target, data1, data2, data3)
		local quest=gdQuests[data1]
		if quest then
			return text.get("notification_bottom_28") .. quest.name , noteType.NORMAL
		end
		return "" , noteType.NORMAL
	end,

	[602] = function(source, target, data1, data2, data3)
		local quest=gdQuests[data1]
		if quest then
			local targetdata = quest.target_datay
			local nowdata = gdceapon.get_sub_data("task","current_task_list",data1,"data_2") or 0
			if targetdata==0 then
				return "" , noteType.NORMAL
			end
			return quest.name..":" .. nowdata .."/".. targetdata  , noteType.NORMAL
		end
		return "" , noteType.NORMAL
	end,

	[603] = function(source, target, data1, data2, data3)
		local quest=gdQuests[data1]
		if quest and data2==2 then
			return text.get("notification_bottom_29") .. quest.name , noteType.NORMAL
		end
		return ""  , noteType.NORMAL
	end,

	[604] = function(source, target, data1, data2, data3)
		local quest=gdQuests[data1]
		if quest and data2==1 then
			return text.get("notification_bottom_30") .. quest.name , noteType.NORMAL
		end
		return ""  , noteType.NORMAL
	end,

	[605] = function(source, target, data1, data2, data3)
		local quest=gdQuests[data1]
		if quest and data2==0 then
			return text.get("notification_bottom_31") .. quest.name , noteType.NORMAL
		end
		return ""  , noteType.NORMAL
	end,
	[803] = function(source, target, data1, data2, data3)
		if data1==1 then	-- is Activity
			if data3==1 then -- Will Begin
				local ed = gdEventData[data2]
				if ed and ed.hidetip ~= 1 then
					local who = ""
					local lvl = ed.requirelvl or 0
					local rb = ed.reborn or 0
					if rb==0 and lvl==1 then
						who = text.get("notification_bottom_32")
					else
						if rb>1 then
							who = rb..text.get("notification_bottom_33")
						end
						if lvl>1 then
							who = who .. lvl ..text.get("notification_bottom_34")
						end
					end

					return ed.name..text.get("notification_bottom_35")..who..text.get("notification_bottom_36"), noteType.TOP
				end
			elseif data3==2 then
				local ed = gdEventData[data2]
				if ed and ed.hidetip ~= 1 then
					return ed.name..text.get("notification_bottom_37"), noteType.TOP
				end
			elseif data3==0 then
				local ed = gdEventData[data2]
				if ed and ed.hidetip ~= 1 then
					return ed.name..text.get("notification_bottom_38"), noteType.TOP
				end
			end
		end
		return "", noteType.DEBUG
	end,

	[812] = function(source, target, data1, data2, data3)
		local emigdata = gdEmigrated[data1]
		if emigdata then
			local name = emigdata.name or ""
			return text.get("notification_bottom_39") .. name ..text.get("notification_bottom_40") , noteType.NORMAL
		end
		return "", noteType.NORMAL
	end,

	[1026] = function(source, target, data1, data2, data3)
		return text.get("notification_bottom_41")..data1..text.get("notification_bottom_42") , noteType.NORMAL
	end,

	[2000] = function(source, target, data1, data2, data3)
		return text.get("notification_bottom_43"), noteType.NORMAL
	end,

	[2008] = function(source, target, data1, data2, data3)
		return  text.get("notification_bottom_44")..data1, noteType.NORMAL
	end,

	[5000] = function(source, target, data1, data2, data3)
		local name = data1 or text.get("notification_bottom_45")
		local pid = data2 or 0
		if (pid == gdceapon.get_data("hero", "pid")) then
			name = text.get("notification_bottom_46")
		end
		return name .. text.get("notification_bottom_47"), noteType.NORMAL
	end,

	[5001] = function(source, target, data1, data2, data3)
		local name = data1 or text.get("notification_bottom_45")
		local pid = data2 or 0
		if (pid == gdceapon.get_data("hero", "pid")) then
			name = text.get("notification_bottom_46")
		end
		return name .. text.get("notification_bottom_48"), noteType.NORMAL
	end,

	[5002] = function(source, target, data1, data2, data3)
		return text.get("notification_bottom_49"), noteType.NORMAL
	end,

	[5003] = function(source, target, data1, data2, data3)
		local name = data1 or text.get("notification_bottom_45")
		local pid = data2 or 0
		if (pid == gdceapon.get_data("hero", "pid")) then
			name = text.get("notification_bottom_46")
		end
		return name .. text.get("notification_bottom_50"), noteType.NORMAL
	end,
}

---------------------------------------------------------
--[[
namespace CPModuleName
{
	static const std::string EVENT = "event";
}

namespace CPEventData
{
	static const std::string SOURCE = "source";
	static const std::string TARGET = "target";

	// data
	static const std::string VALUE_1 = "value_1";
	static const std::string VALUE_2 = "value_2";
	static const std::string VALUE_3 = "value_3";
	static const std::string VALUE_4 = "value_4";
	static const std::string VALUE_5 = "value_5";
}

namespace CPEventName
{
	// event from msg
	static const std::string MSG_CHANGE = "msg_change";
	static const std::string MSG_FINISH = "msg_finish";

	static const std::string UI_NOTIFY = "ui_notify";
}
--]]
cpnotification = init_table_safely(cpnotification)
cpnotification.on_cp_event = function(eventName)
	if (eventName == "msg_finish") or (eventName == "ui_notify") then
		local errcode = gdceapon.get_sub_data("event", eventName, 1, "value_1")
		if errcode then
			local getMsg = getErrorMsg[errcode]
			if getMsg then
				local source = gdceapon.get_sub_data("event", eventName, 1, "source") or ""
				local target = gdceapon.get_sub_data("event", eventName, 1, "target") or ""
				local note, noteType = getMsg(source, target)
				addNote(note, noteType)
			else
				addNote(text.get("notification_bottom_51")..tostring(errcode), noteType.NORMAL)
			end
		end
	elseif (eventName == "msg_change") then
		local hasEnterScene = gdceapon.get_data("scene", "has_enter_scene")
		if (hasEnterScene ~= 1) then
			return
		end

		local opcode = gdceapon.get_sub_data("event", eventName, 1, "value_1")
		if opcode then
			local getMsg = getOperationMsg[opcode]
			if getMsg then
				local source = gdceapon.get_sub_data("event", eventName, 1, "source") or ""
				local target = gdceapon.get_sub_data("event", eventName, 1, "target") or ""
				local data1 = gdceapon.get_sub_data("event", eventName, 1, "value_2") or 0
				local data2 = gdceapon.get_sub_data("event", eventName, 1, "value_3") or 0
				local data3 = gdceapon.get_sub_data("event", eventName, 1, "value_4") or 0
				local data4 = gdceapon.get_sub_data("event", eventName, 1, "value_5") or 0
				local note, noteType = getMsg(source, target, data1, data2, data3, data4)
				if (type(noteType) == "number") and (noteType > 0) then
					addNote(note, noteType)
				else
					log.error("cpnotification.on_cp_event, msg_change, invalid noteType. opcode = " .. opcode)
				end
			else
				--addNote("opcode = "..tostring(opcode), noteType.NORMAL)
			end
		end
	end
end

------------------------------------------------------



















